#' OpenAPI Petstore
#'
#' This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#'
#' The version of the OpenAPI document: 1.0.0
#' Generated by: https://openapi-generator.tech
#'

#' @docType class
#' @title Pet operations
#' @description petstore.Pet
#' @format An \code{R6Class} generator object
#' @field api_client Handles the client-server communication.
#'
#' @section Methods:
#' \describe{
#' \strong{ AddPet } \emph{ Add a new pet to the store }
#' 
#'
#' \itemize{
#' \item \emph{ @param } pet \link{Pet}
#' \item \emph{ @returnType } \link{Pet} \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : Pet 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 405 | Invalid input
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ DeletePet } \emph{ Deletes a pet }
#' 
#'
#' \itemize{
#' \item \emph{ @param } pet_id integer
#' \item \emph{ @param } api_key character
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 400 | Invalid pet value
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ FindPetsByStatus } \emph{ Finds Pets by status }
#' Multiple status values can be provided with comma separated strings
#'
#' \itemize{
#' \item \emph{ @param } status Enum < [available, pending, sold] >
#' \item \emph{ @returnType } list( \link{Pet} ) \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : array[Pet] 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 400 | Invalid status value
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ FindPetsByTags } \emph{ Finds Pets by tags }
#' Multiple tags can be provided with comma separated strings. Use tag1, tag2, tag3 for testing.
#'
#' \itemize{
#' \item \emph{ @param } tags list( character )
#' \item \emph{ @returnType } list( \link{Pet} ) \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : array[Pet] 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 400 | Invalid tag value
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ GetPetById } \emph{ Find pet by ID }
#' Returns a single pet
#'
#' \itemize{
#' \item \emph{ @param } pet_id integer
#' \item \emph{ @returnType } \link{Pet} \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : Pet 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 400 | Invalid ID supplied
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 404 | Pet not found
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ GetPetByIdStreaming } \emph{ Find pet by ID (streaming) }
#' Returns a single pet
#'
#' \itemize{
#' \item \emph{ @param } pet_id integer
#' \item \emph{ @returnType } \link{Pet} \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : Pet 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 400 | Invalid ID supplied
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 404 | Pet not found
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ UpdatePet } \emph{ Update an existing pet }
#' 
#'
#' \itemize{
#' \item \emph{ @param } pet \link{Pet}
#' \item \emph{ @returnType } \link{Pet} \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : Pet 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 400 | Invalid ID supplied
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 404 | Pet not found
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' \item status code : 405 | Validation exception
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ UpdatePetWithForm } \emph{ Updates a pet in the store with form data }
#' 
#'
#' \itemize{
#' \item \emph{ @param } pet_id integer
#' \item \emph{ @param } name character
#' \item \emph{ @param } status character
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 405 | Invalid input
#'
#'
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' \strong{ UploadFile } \emph{ uploads an image }
#' 
#'
#' \itemize{
#' \item \emph{ @param } pet_id integer
#' \item \emph{ @param } additional_metadata character
#' \item \emph{ @param } file data.frame
#' \item \emph{ @returnType } \link{ModelApiResponse} \cr
#'
#' \item On encountering errors, an error of subclass ApiException will be thrown.
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : ModelApiResponse 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' }
#'
#'
#' @examples
#' \dontrun{
#' ####################  AddPet  ####################
#'
#' library(petstore)
#' var.pet <- Pet$new() # Pet | Pet object that needs to be added to the store
#'
#' #Add a new pet to the store
#' api.instance <- PetApi$new()
#'
#' # Configure OAuth2 access token for authorization: petstore_auth
#' api.instance$api_client$access_token <- 'TODO_YOUR_ACCESS_TOKEN';
#'
#'result <- tryCatch(
#'             api.instance$AddPet(var.pet),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  DeletePet  ####################
#'
#' library(petstore)
#' var.pet_id <- 56 # integer | Pet id to delete
#' var.api_key <- "api_key_example" # character | 
#'
#' #Deletes a pet
#' api.instance <- PetApi$new()
#'
#' # Configure OAuth2 access token for authorization: petstore_auth
#' api.instance$api_client$access_token <- 'TODO_YOUR_ACCESS_TOKEN';
#'
#'result <- tryCatch(
#'             api.instance$DeletePet(var.pet_id, api_key=var.api_key),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  FindPetsByStatus  ####################
#'
#' library(petstore)
#' var.status <- ["status_example"] # array[character] | Status values that need to be considered for filter
#'
#' #Finds Pets by status
#' api.instance <- PetApi$new()
#'
#' # Configure OAuth2 access token for authorization: petstore_auth
#' api.instance$api_client$access_token <- 'TODO_YOUR_ACCESS_TOKEN';
#'
#'result <- tryCatch(
#'             api.instance$FindPetsByStatus(var.status),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  FindPetsByTags  ####################
#'
#' library(petstore)
#' var.tags <- ["tags_example"] # array[character] | Tags to filter by
#'
#' #Finds Pets by tags
#' api.instance <- PetApi$new()
#'
#' # Configure OAuth2 access token for authorization: petstore_auth
#' api.instance$api_client$access_token <- 'TODO_YOUR_ACCESS_TOKEN';
#'
#'result <- tryCatch(
#'             api.instance$FindPetsByTags(var.tags),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  GetPetById  ####################
#'
#' library(petstore)
#' var.pet_id <- 56 # integer | ID of pet to return
#'
#' #Find pet by ID
#' api.instance <- PetApi$new()
#'
#' #Configure API key authorization: api_key
#' api.instance$api_client$api_keys['api_key'] <- 'TODO_YOUR_API_KEY';
#'
#'result <- tryCatch(
#'             api.instance$GetPetById(var.pet_id),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  GetPetByIdStreaming  ####################
#'
#' library(petstore)
#' var.pet_id <- 56 # integer | ID of pet to return
#'
#' #Find pet by ID (streaming)
#' api.instance <- PetApi$new()
#'
#' #Configure API key authorization: api_key
#' api.instance$api_client$api_keys['api_key'] <- 'TODO_YOUR_API_KEY';
#'
#'result <- tryCatch(
#'             api.instance$GetPetByIdStreaming(var.pet_id),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  UpdatePet  ####################
#'
#' library(petstore)
#' var.pet <- Pet$new() # Pet | Pet object that needs to be added to the store
#'
#' #Update an existing pet
#' api.instance <- PetApi$new()
#'
#' # Configure OAuth2 access token for authorization: petstore_auth
#' api.instance$api_client$access_token <- 'TODO_YOUR_ACCESS_TOKEN';
#'
#'result <- tryCatch(
#'             api.instance$UpdatePet(var.pet),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  UpdatePetWithForm  ####################
#'
#' library(petstore)
#' var.pet_id <- 56 # integer | ID of pet that needs to be updated
#' var.name <- "name_example" # character | Updated name of the pet
#' var.status <- "status_example" # character | Updated status of the pet
#'
#' #Updates a pet in the store with form data
#' api.instance <- PetApi$new()
#'
#' # Configure OAuth2 access token for authorization: petstore_auth
#' api.instance$api_client$access_token <- 'TODO_YOUR_ACCESS_TOKEN';
#'
#'result <- tryCatch(
#'             api.instance$UpdatePetWithForm(var.pet_id, name=var.name, status=var.status),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' ####################  UploadFile  ####################
#'
#' library(petstore)
#' var.pet_id <- 56 # integer | ID of pet to update
#' var.additional_metadata <- "additional_metadata_example" # character | Additional data to pass to server
#' var.file <- File.new('/path/to/file') # data.frame | file to upload
#'
#' #uploads an image
#' api.instance <- PetApi$new()
#'
#' # Configure OAuth2 access token for authorization: petstore_auth
#' api.instance$api_client$access_token <- 'TODO_YOUR_ACCESS_TOKEN';
#'
#'result <- tryCatch(
#'             api.instance$UploadFile(var.pet_id, additional_metadata=var.additional_metadata, file=var.file),
#'             ApiException = function(ex) ex
#'          )
#' # In case of error, print the error object
#' if(!is.null(result$ApiException)) {
#'   cat(result$ApiException$toString())
#' } else {
#' # deserialized response object
#' response.object <- result$content
#' # response headers
#' response.headers <- result$response$headers
#' # response status code
#' response.status.code <- result$response$status_code
#' }
#'
#'
#' }
#' @importFrom R6 R6Class
#' @importFrom base64enc base64encode
#' @importFrom rlang abort
#' @export
PetApi <- R6::R6Class(
  "PetApi",
  public = list(
    api_client = NULL,
    #' Initialize a new PetApi.
    #'
    #' @description
    #' Initialize a new PetApi.
    #'
    #' @param api_client An instance of API client.
    #' @export
    initialize = function(api_client) {
      if (!missing(api_client)) {
        self$api_client <- api_client
      } else {
        self$api_client <- ApiClient$new()
      }
    },
    #' Add a new pet to the store
    #'
    #' @description
    #' Add a new pet to the store
    #'
    #' @param pet Pet object that needs to be added to the store
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return Pet
    #' @export
    AddPet = function(pet, data_file = NULL, ...) {
      api_response <- self$AddPetWithHttpInfo(pet, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Add a new pet to the store
    #'
    #' @description
    #' Add a new pet to the store
    #'
    #' @param pet Pet object that needs to be added to the store
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (Pet) with additional information such as HTTP status code, headers
    #' @export
    AddPetWithHttpInfo = function(pet, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`pet`)) {
        rlang::abort(message = "Missing required parameter `pet`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `pet`."))
      }

      if (!missing(`pet`)) {
        body <- `pet`$toJSONString()
      } else {
        body <- NULL
      }

      url_path <- "/pet"
      # OAuth token
      header_params["Authorization"] <- paste("Bearer", self$api_client$access_token, sep = " ")

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "POST",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "Pet", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response",
                          .subclass = "ApiException",
                          ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Deletes a pet
    #'
    #' @description
    #' Deletes a pet
    #'
    #' @param pet_id Pet id to delete
    #' @param api_key (optional) 
    #' @param ... Other optional arguments
    #' @return void
    #' @export
    DeletePet = function(pet_id, api_key=NULL, ...) {
      api_response <- self$DeletePetWithHttpInfo(pet_id, api_key, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Deletes a pet
    #'
    #' @description
    #' Deletes a pet
    #'
    #' @param pet_id Pet id to delete
    #' @param api_key (optional) 
    #' @param ... Other optional arguments
    #' @return API response (void) with additional information such as HTTP status code, headers
    #' @export
    DeletePetWithHttpInfo = function(pet_id, api_key=NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`pet_id`)) {
        rlang::abort(message = "Missing required parameter `pet_id`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `pet_id`."))
      }

      body <- NULL
      url_path <- "/pet/{petId}?streaming"
      if (!missing(`pet_id`)) {
        url_path <- gsub(paste0("\\{", "petId", "\\}"), URLencode(as.character(`pet_id`), reserved = TRUE), url_path)
      }

      # OAuth token
      header_params["Authorization"] <- paste("Bearer", self$api_client$access_token, sep = " ")

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "DELETE",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        ApiResponse$new(NULL, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Finds Pets by status
    #'
    #' @description
    #' Finds Pets by status
    #'
    #' @param status Status values that need to be considered for filter
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return array[Pet]
    #' @export
    FindPetsByStatus = function(status, data_file = NULL, ...) {
      api_response <- self$FindPetsByStatusWithHttpInfo(status, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Finds Pets by status
    #'
    #' @description
    #' Finds Pets by status
    #'
    #' @param status Status values that need to be considered for filter
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (array[Pet]) with additional information such as HTTP status code, headers
    #' @export
    FindPetsByStatusWithHttpInfo = function(status, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`status`)) {
        rlang::abort(message = "Missing required parameter `status`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `status`."))
      }

      body <- NULL
      url_path <- "/pet/findByStatus"
      # OAuth token
      header_params["Authorization"] <- paste("Bearer", self$api_client$access_token, sep = " ")

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "GET",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "array[Pet]", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response",
                          .subclass = "ApiException",
                          ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Finds Pets by tags
    #'
    #' @description
    #' Finds Pets by tags
    #'
    #' @param tags Tags to filter by
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return array[Pet]
    #' @export
    FindPetsByTags = function(tags, data_file = NULL, ...) {
      api_response <- self$FindPetsByTagsWithHttpInfo(tags, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Finds Pets by tags
    #'
    #' @description
    #' Finds Pets by tags
    #'
    #' @param tags Tags to filter by
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (array[Pet]) with additional information such as HTTP status code, headers
    #' @export
    FindPetsByTagsWithHttpInfo = function(tags, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`tags`)) {
        rlang::abort(message = "Missing required parameter `tags`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `tags`."))
      }

      body <- NULL
      url_path <- "/pet/findByTags"
      # OAuth token
      header_params["Authorization"] <- paste("Bearer", self$api_client$access_token, sep = " ")

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "GET",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "array[Pet]", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response",
                          .subclass = "ApiException",
                          ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Find pet by ID
    #'
    #' @description
    #' Find pet by ID
    #'
    #' @param pet_id ID of pet to return
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return Pet
    #' @export
    GetPetById = function(pet_id, data_file = NULL, ...) {
      api_response <- self$GetPetByIdWithHttpInfo(pet_id, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Find pet by ID
    #'
    #' @description
    #' Find pet by ID
    #'
    #' @param pet_id ID of pet to return
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (Pet) with additional information such as HTTP status code, headers
    #' @export
    GetPetByIdWithHttpInfo = function(pet_id, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`pet_id`)) {
        rlang::abort(message = "Missing required parameter `pet_id`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `pet_id`."))
      }

      body <- NULL
      url_path <- "/pet/{petId}"
      if (!missing(`pet_id`)) {
        url_path <- gsub(paste0("\\{", "petId", "\\}"), URLencode(as.character(`pet_id`), reserved = TRUE), url_path)
      }

      # API key authentication
      if ("api_key" %in% names(self$api_client$api_keys) && nchar(self$api_client$api_keys["api_key"]) > 0) {
        header_params["api_key"] <- paste(unlist(self$api_client$api_keys["api_key"]), collapse = "")
      }

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "GET",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "Pet", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response",
                          .subclass = "ApiException",
                          ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Find pet by ID (streaming)
    #'
    #' @description
    #' Find pet by ID (streaming)
    #'
    #' @param pet_id ID of pet to return
    #' @param stream_callback (optional) callback function to process the data stream
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return Pet
    #' @export
    GetPetByIdStreaming = function(pet_id, stream_callback=NULL, data_file = NULL, ...) {
      api_response <- self$GetPetByIdStreamingWithHttpInfo(pet_id, stream_callback = stream_callback, data_file = data_file, ...)
      if (typeof(stream_callback) == "closure") { # return void if streaming is enabled
        return(invisible(NULL))
      }

      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Find pet by ID (streaming)
    #'
    #' @description
    #' Find pet by ID (streaming)
    #'
    #' @param pet_id ID of pet to return
    #' @param stream_callback (optional) callback function to process the data stream
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (Pet) with additional information such as HTTP status code, headers
    #' @export
    GetPetByIdStreamingWithHttpInfo = function(pet_id, stream_callback=NULL, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`pet_id`)) {
        rlang::abort(message = "Missing required parameter `pet_id`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `pet_id`."))
      }

      body <- NULL
      url_path <- "/pet/{petId}?streaming"
      if (!missing(`pet_id`)) {
        url_path <- gsub(paste0("\\{", "petId", "\\}"), URLencode(as.character(`pet_id`), reserved = TRUE), url_path)
      }

      # API key authentication
      if ("api_key" %in% names(self$api_client$api_keys) && nchar(self$api_client$api_keys["api_key"]) > 0) {
        header_params["api_key"] <- paste(unlist(self$api_client$api_keys["api_key"]), collapse = "")
      }

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "GET",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 stream_callback = stream_callback,
                                 ...)

      if (typeof(stream_callback) == "closure") { # return void if streaming is enabled
        return(invisible(NULL))
      }

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "Pet", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response",
                          .subclass = "ApiException",
                          ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Update an existing pet
    #'
    #' @description
    #' Update an existing pet
    #'
    #' @param pet Pet object that needs to be added to the store
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return Pet
    #' @export
    UpdatePet = function(pet, data_file = NULL, ...) {
      api_response <- self$UpdatePetWithHttpInfo(pet, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Update an existing pet
    #'
    #' @description
    #' Update an existing pet
    #'
    #' @param pet Pet object that needs to be added to the store
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (Pet) with additional information such as HTTP status code, headers
    #' @export
    UpdatePetWithHttpInfo = function(pet, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`pet`)) {
        rlang::abort(message = "Missing required parameter `pet`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `pet`."))
      }

      if (!missing(`pet`)) {
        body <- `pet`$toJSONString()
      } else {
        body <- NULL
      }

      url_path <- "/pet"
      # OAuth token
      header_params["Authorization"] <- paste("Bearer", self$api_client$access_token, sep = " ")

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "PUT",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "Pet", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response",
                          .subclass = "ApiException",
                          ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' Updates a pet in the store with form data
    #'
    #' @description
    #' Updates a pet in the store with form data
    #'
    #' @param pet_id ID of pet that needs to be updated
    #' @param name (optional)Updated name of the pet 
    #' @param status (optional)Updated status of the pet 
    #' @param ... Other optional arguments
    #' @return void
    #' @export
    UpdatePetWithForm = function(pet_id, name=NULL, status=NULL, ...) {
      api_response <- self$UpdatePetWithFormWithHttpInfo(pet_id, name, status, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' Updates a pet in the store with form data
    #'
    #' @description
    #' Updates a pet in the store with form data
    #'
    #' @param pet_id ID of pet that needs to be updated
    #' @param name (optional) Updated name of the pet
    #' @param status (optional) Updated status of the pet
    #' @param ... Other optional arguments
    #' @return API response (void) with additional information such as HTTP status code, headers
    #' @export
    UpdatePetWithFormWithHttpInfo = function(pet_id, name=NULL, status=NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`pet_id`)) {
        rlang::abort(message = "Missing required parameter `pet_id`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `pet_id`."))
      }

      body <- list(
        "name" = name,
        "status" = status
      )

      url_path <- "/pet/{petId}?streaming"
      if (!missing(`pet_id`)) {
        url_path <- gsub(paste0("\\{", "petId", "\\}"), URLencode(as.character(`pet_id`), reserved = TRUE), url_path)
      }

      # OAuth token
      header_params["Authorization"] <- paste("Bearer", self$api_client$access_token, sep = " ")

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "POST",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        ApiResponse$new(NULL, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    },
    #' uploads an image
    #'
    #' @description
    #' uploads an image
    #'
    #' @param pet_id ID of pet to update
    #' @param additional_metadata (optional)Additional data to pass to server 
    #' @param file (optional)file to upload 
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return ModelApiResponse
    #' @export
    UploadFile = function(pet_id, additional_metadata=NULL, file=NULL, data_file = NULL, ...) {
      api_response <- self$UploadFileWithHttpInfo(pet_id, additional_metadata, file, data_file = data_file, ...)
      resp <- api_response$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        api_response$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        api_response
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        api_response
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        api_response
      }
    },
    #' uploads an image
    #'
    #' @description
    #' uploads an image
    #'
    #' @param pet_id ID of pet to update
    #' @param additional_metadata (optional) Additional data to pass to server
    #' @param file (optional) file to upload
    #' @param data_file (optional) name of the data file to save the result
    #' @param ... Other optional arguments
    #' @return API response (ModelApiResponse) with additional information such as HTTP status code, headers
    #' @export
    UploadFileWithHttpInfo = function(pet_id, additional_metadata=NULL, file=NULL, data_file = NULL, ...) {
      args <- list(...)
      query_params <- list()
      header_params <- c()

      if (missing(`pet_id`)) {
        rlang::abort(message = "Missing required parameter `pet_id`.",
                     .subclass = "ApiException",
                     ApiException = ApiException$new(status = 0,
                                                     reason = "Missing required parameter `pet_id`."))
      }

      body <- list(
        "additionalMetadata" = additional_metadata,
        "file" = httr::upload_file(file)
      )

      url_path <- "/pet/{petId}/uploadImage"
      if (!missing(`pet_id`)) {
        url_path <- gsub(paste0("\\{", "petId", "\\}"), URLencode(as.character(`pet_id`), reserved = TRUE), url_path)
      }

      # OAuth token
      header_params["Authorization"] <- paste("Bearer", self$api_client$access_token, sep = " ")

      resp <- self$api_client$CallApi(url = paste0(self$api_client$base_path, url_path),
                                 method = "POST",
                                 query_params = query_params,
                                 header_params = header_params,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserialized_resp_obj <- tryCatch(
          self$api_client$deserialize(resp, "ModelApiResponse", loadNamespace("petstore")),
          error = function(e) {
             rlang::abort(message = "Failed to deserialize response",
                          .subclass = "ApiException",
                          ApiException = ApiException$new(http_response = resp))
          }
        )
        ApiResponse$new(deserialized_resp_obj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        error_msg <- toString(content(resp))
        if (error_msg == "") {
          error_msg <- paste("Server returned ", httr::status_code(resp), " response status code.")
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api client exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        error_msg <- toString(content(resp))
        if(error_msg == "") {
          error_msg <- "Api server exception encountered."
        }
        rlang::abort(message = error_msg,
                     .subclass = "ApiException",
                     ApiException = ApiException$new(http_response = resp))
      }
    }
  )
)
